﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;

namespace WebRole.Controllers
{
    public class WebpageController : Controller
    {
        private Stream GetThumbnail(string url)
        {
            if (!url.ToLower().StartsWith("http://")) url = "http://" + url;
            var filename = Path.GetTempFileName() + ".png";
            Process.Start(new ProcessStartInfo(Server.MapPath("~/bin/cutycapt.exe"), string.Format("--url={0} --out={1} --max-wait=10000", url, filename))
            {
                UseShellExecute = false,
                CreateNoWindow = true
            }).WaitForExit(30000);
            var ms = new MemoryStream();
            using (var img = Image.FromFile(filename))
            {
                var bmp = new Bitmap(300, 200);
                using (var g = Graphics.FromImage(bmp))
                {
                    g.DrawImage(img, 0, 0, 300, img.Height * 300 / img.Width);
                    g.FillRectangle(new SolidBrush(Color.FromArgb(160, Color.Black)), 0, 150, 300, 50);
                    g.DrawString(string.Format("Generated at:\n{0} UTC", DateTime.UtcNow), new Font("Arial", 16), Brushes.White, new PointF(0, 150));
                }
                bmp.Save(ms, ImageFormat.Png);
            }
            System.IO.File.Delete(filename);
            ms.Position = 0;
            return ms;
        }

        public ActionResult Fetch()
        {
            Response.Cache.SetCacheability(HttpCacheability.Public);
            Response.Cache.SetMaxAge(TimeSpan.FromMinutes(5));
            return new FileStreamResult(GetThumbnail(Request.QueryString["url"]), "image/png");
        }
    }
}
